
.486
.model flat, stdcall	; 32-bit code.
option casemap:none	; case-sensitive.

; Includes.
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\ole32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\macros\macros.asm

include main.inc
include ..\Image\image.inc

include Utils.asm

; Libraries.
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib

includelib ..\Image\image.lib

; Prototypes.
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
MainDialogProc proto :DWORD,:DWORD,:DWORD,:DWORD
LoginDialogProc proto :DWORD,:DWORD,:DWORD,:DWORD
AboutDialogProc proto :DWORD,:DWORD,:DWORD,:DWORD
ShowLoginXP proto :DWORD,:DWORD

WM_TRAYMESSAGE	equ	(WM_USER+300h)
TRAYICONID	equ	1000h

; Uninitialized data.
.data?

align 4

hWnd		dd	?	; Main window handle.
hInstance	dd	?	; Application instance handle.
hLogo		dd	?
hMainMenu	dd	?	; Main window context menu.
hConsoleMenu	dd	?	; Console (listbox) context menu.
hMutex		dd	?	; Mutex handle.
hAboutFont	dd	?	; About font.

LoginResult	dd	?	; Login dialog result (0 means OK, 1 means cancel).
bMinimized	dd	?	; Indicates whether the window is minimized to tray.

szUsername	db	50 dup(?)
szPassword	db	50 dup(?)

nid		NOTIFYICONDATA	<?>

; Initialized data.
.data

align 4

szMutex		db	"4CVobIme9EAAEhuAEgxKn",0
szAppNameShort	db	"DB Client",0
szHalfLife	db	"HL.EXE",0
szSteamApps	db	"SteamApps",0

szDescription	db	"DB Client",0dh,0ah,0dh,0ah
		db	"Greetings fly out to my friends - you know who you are. ;)",0

; Error messages.
szErrorFatal	db	"DB Client has caused an internal fatal error, and has to close. Please notify the support about this issue.", 0
szErrorInstance	db	"DB Client is already opened. Please switch to the first instance of SKAC or use the Task Manager to terminate the existing instance.",0
szProcessFail	db	"DB Client must be opened before Half-Life!",0

; Misc.
lb		LOGBRUSH	<0,0ffffffh,BS_SOLID>
font		LOGFONT		<-10,0,0,0,700,FALSE,FALSE,FALSE,0,0,0,0,0,'MS Sans Serif'>

.code

start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax

align 4

WinMain proc hinst:DWORD,hprev:DWORD,cmdline:DWORD,cmdshow:DWORD
	invoke DialogBoxParam,hInstance,IDD_MAIN,0,addr MainDialogProc,0
	invoke ExitProcess,0
	xor eax,eax
	ret
WinMain endp

align 4

MainDialogProc proc hwnd:DWORD,m:DWORD,w:DWORD,l:DWORD
	; Local variables.

	; WM_INITDIALOG
	LOCAL hSnapshot:HANDLE
	LOCAL pe32:PROCESSENTRY32
	LOCAL bEnum:BOOL

	; WM_PAINT
	LOCAL ps:PAINTSTRUCT
	LOCAL hDC:HDC
	LOCAL hMemDC:HDC
	LOCAL hOld:HGDIOBJ

	; WM_ERASEBKGND
	LOCAL hBrush:HBRUSH
	LOCAL rc:RECT

	; WM_CONTEXTMENU
	LOCAL consolehWnd:HWND	; Console window handle.
	LOCAL cnt:DWORD		; Listbox items count.
	LOCAL item[50]:BYTE	; Listbox item contentholder.
	LOCAL gbuf:HGLOBAL	; Global memory handle.
	LOCAL glock:DWORD	; Global memory lock.
	;LOCAL itemlen:DWORD	; Listbox item length.

	; WM_COMMAND
	LOCAL md5buf[16]:BYTE	; MD5 output buffer.

	.if m==WM_INITDIALOG
		invoke InitCommonControls	; For XP-theme support.

		; Create mutex or exit if mutex already exists.
		invoke CreateMutex,NULL,TRUE,addr szMutex
		mov hMutex,eax
		invoke GetLastError
		cmp eax,ERROR_ALREADY_EXISTS
		je error2

		; Check for HL.
		invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0
		inc eax
		jz error1
		dec eax
		mov hSnapshot,eax
		mov pe32.dwSize,sizeof pe32
		invoke Process32First,hSnapshot,addr pe32
		test eax,eax
		jz error1

		.repeat
			invoke Cmpi,addr pe32.szExeFile,addr szHalfLife
			test eax,eax
			jz match
			invoke Process32Next,hSnapshot,addr pe32
			mov bEnum,eax
			.continue
match:
			invoke MessageBox,hwnd,addr szProcessFail,addr szAppNameShort,MB_ICONERROR OR MB_OK
			invoke CloseHandle,hSnapshot
			jmp Close
		.until !bEnum

		invoke CloseHandle,hSnapshot

		; Setup NOTIFYICONDATA structure.
		mov nid.cbSize,sizeof nid
		mov nid.uID,TRAYICONID
		mov nid.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
		invoke LoadImage,hInstance,IDI_ICON,IMAGE_ICON,\
							FUNC(GetSystemMetrics,SM_CXSMICON),\
							FUNC(GetSystemMetrics,SM_CYSMICON),\
							LR_DEFAULTCOLOR
		mov nid.hIcon,eax
		invoke lstrcpy,addr nid.szTip,addr szAppNameShort
		m2m nid.hwnd,hwnd
		mov nid.uCallbackMessage,WM_TRAYMESSAGE
		
		; Load logo.
		invoke CoInitialize,NULL	; Initialize COM.
		invoke BitmapFromResource,hInstance,IDI_LOGO
		test eax,eax
		jz error1

		mov hLogo,eax			; Store bitmap handle.
		m2m hWnd,hwnd			; Store window handle.

		invoke CreatePopupMenu
		mov hMainMenu,eax
		invoke AppendMenu,eax,MF_STRING,1,SADD("About")

		invoke CreatePopupMenu
		mov hConsoleMenu,eax
		invoke AppendMenu,eax,MF_STRING,1,SADD("Copy to clipboard")

		invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_ADDSTRING,NULL,SADD("testing")
		invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_ADDSTRING,NULL,SADD("testing2")
		invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_ADDSTRING,NULL,SADD("testing3")
		invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_ADDSTRING,NULL,SADD("testing4")

		invoke MD5_Startup
		jmp initend

error1:
		invoke MessageBox,hwnd,addr szErrorFatal,addr szAppNameShort,MB_ICONERROR OR MB_OK
		jmp Close
error2:
		invoke MessageBox,hwnd,addr szErrorInstance,addr szAppNameShort,MB_ICONWARNING OR MB_OK
		jmp Close
error3:
		invoke MessageBox,hwnd,addr szProcessFail,addr szAppNameShort,MB_ICONERROR OR MB_OK
		jmp Close

initend:
		mov eax,1
		ret
	.elseif m==WM_PAINT
		invoke BeginPaint,hwnd,addr ps
		mov hDC,eax

		invoke CreateCompatibleDC,hDC
		mov hMemDC,eax

		invoke SelectObject,hMemDC,hLogo
		mov hOld,eax

		invoke BitBlt,hDC,12,-3,336,156,hMemDC,0,0,SRCCOPY
		invoke DeleteDC,hMemDC
		invoke EndPaint,hwnd,addr ps
	.elseif m==WM_ERASEBKGND
		invoke CreateBrushIndirect,addr lb
		mov hBrush,eax

		invoke GetClientRect,hwnd,addr rc
		invoke FillRect,w,addr rc,hBrush

		mov eax,1
		ret
	.elseif m==WM_SYSCOMMAND
		.if w==SC_MINIMIZE
			invoke Shell_NotifyIcon,NIM_ADD,addr nid
			invoke ShowWindow,hwnd,SW_HIDE
			invoke SetWindowLong,hwnd,DWL_MSGRESULT,0
			mov bMinimized,TRUE
			mov eax,1
			ret
		.endif
	.elseif m==WM_TRAYMESSAGE
		.if l==WM_LBUTTONDBLCLK
			.if bMinimized
				invoke Shell_NotifyIcon,NIM_DELETE,addr nid
				invoke ShowWindow,hwnd,SW_RESTORE
				invoke SetActiveWindow,hwnd
				invoke SetForegroundWindow,hwnd
				mov bMinimized,FALSE
				mov eax,1
				ret
			.endif
		.endif
	.elseif m==WM_COMMAND
		mov eax,w
		.if ax==IDD_CLOSE
			jmp Close
		.elseif ax==IDD_CONNECT
			invoke DialogBoxParam,hInstance,IDD_LOGIN,hwnd,addr LoginDialogProc,0

			cmp LoginResult,1
			je bail_out
check_details:
			invoke szLen,addr szUsername
			mov ecx,eax
			invoke szLen,addr szPassword

			.if ((ecx<3 || ecx>16) || (eax<3 || eax>16))
				jmp bail_out
			.endif

			invoke md5string,addr szPassword,addr md5buf
			invoke MessageBox,hwnd,addr md5buf,SADD("Test"),MB_OK
bail_out:
			xor eax,eax
			ret
		.endif
	.elseif m==WM_CONTEXTMENU
		invoke GetDlgItem,hwnd,IDC_CONSOLE
		mov consolehWnd,eax
		mov eax,hwnd
		push ebx
		mov ebx,w
		mov ecx,consolehWnd
		.if (eax==ebx) && (hMainMenu!=0)
			mov eax,l
			mov ebx,eax
			and eax,0ffffh
			shr ebx,16
			invoke TrackPopupMenuEx,hMainMenu,TPM_LEFTALIGN OR TPM_RETURNCMD,eax,ebx,w,0
			test eax,eax			
			jz nosel
			invoke DialogBoxParam,hInstance,IDD_ABOUT,hwnd,addr AboutDialogProc,0
			
nosel:
			mov eax,1
			ret
		.elseif (ecx==ebx) && (hConsoleMenu!=0)
			mov eax,l
			mov ebx,eax
			and eax,0ffffh
			shr ebx,16
			invoke TrackPopupMenuEx,hConsoleMenu,TPM_LEFTALIGN OR TPM_RETURNCMD,eax,ebx,w,0
			test eax,eax
			jz failed
			invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_GETCOUNT,0,0
			test eax,eax
			jz failed
			mov cnt,eax
			mov ecx,sizeof item
			mul ecx	; Get total number of bytes to allocate.
			mov ecx,eax
			invoke GlobalAlloc,GMEM_MOVEABLE AND GMEM_DDESHARE,ecx ; I also tried GMEM_FIXED.
			mov gbuf,eax
			invoke GlobalLock,gbuf
			mov byte ptr [eax],0   ;<--- this must be done outside of loop
			mov glock,eax
			push ebx
			xor ebx,ebx
			.while (ebx<cnt)
				invoke SendDlgItemMessage,hwnd,IDC_CONSOLE,LB_GETTEXT,ebx,addr item
				inc ebx
				.continue .if !eax ; Move to next if failed.
				invoke szCatStr,glock,addr item ; Copy item.
				invoke StrLen, glock   ;<--- added
				mov ecx,[glock]
				mov byte ptr [eax+ecx+0],0dh
				mov byte ptr [eax+ecx+1],0ah
				mov byte ptr [eax+ecx+2],00h
			.endw
			invoke GlobalUnlock,gbuf
			pop ebx
			invoke OpenClipboard,hwnd
			test eax,eax
			jz clip_failed
			invoke EmptyClipboard
			invoke GlobalLock,gbuf
			mov glock,eax
			invoke SetClipboardData,CF_TEXT,eax
			invoke CloseClipboard
clip_failed:
			invoke GlobalUnlock,gbuf
			invoke GlobalFree,gbuf
		.endif
failed:
		pop ebx
		ret
	.elseif m==WM_CLOSE
Close:
		invoke EndDialog,hwnd,NULL
		xor eax,eax
		ret
	.elseif m==WM_DESTROY
		invoke ReleaseMutex,hMutex
		invoke CloseHandle,hMutex

		invoke DestroyIcon,nid.hIcon
		mov nid.hIcon,NULL
		mov nid.uFlags,0
		invoke Shell_NotifyIcon,NIM_DELETE,addr nid

		invoke DestroyMenu,hMainMenu
		invoke DestroyMenu,hConsoleMenu
		invoke DeleteObject,hLogo
		invoke CoUninitialize
	.endif

	xor eax,eax
	ret
MainDialogProc endp

align 4

LoginDialogProc proc hwnd:DWORD,m:DWORD,w:DWORD,l:DWORD
	.if m==WM_INITDIALOG
		invoke GetDlgItem,hwnd,IDC_TXTUSERNAME
		invoke SetFocus,eax
	.elseif m==WM_COMMAND
		mov eax,w
		.if ax==IDOK
			invoke SendDlgItemMessage,hwnd,IDC_TXTUSERNAME,WM_GETTEXT,50,addr szUsername
			invoke SendDlgItemMessage,hwnd,IDC_TXTPASSWORD,WM_GETTEXT,50,addr szPassword
			mov LoginResult,0
			jmp Close
		.elseif ax==IDCANCEL
			mov LoginResult,1
			jmp Close
		.endif
	.elseif m==WM_CLOSE
Close:
		invoke EndDialog,hwnd,NULL
		xor eax,eax
		ret
	.endif

	xor eax,eax
	ret
LoginDialogProc endp

align 4

AboutDialogProc proc hwnd:DWORD,m:DWORD,w:DWORD,l:DWORD
	.if m==WM_INITDIALOG
		invoke CreateFontIndirect,addr font
		mov hAboutFont,eax
		invoke SendDlgItemMessage,hwnd,IDC_PRODUCTNAME,WM_SETFONT,eax,TRUE
		invoke SendDlgItemMessage,hwnd,IDC_DESCRIPTION,WM_SETTEXT,NULL,addr szDescription
		mov eax,1
		ret
	.elseif m==WM_COMMAND
		mov eax,w
		.if ax==IDOK
			jmp Close
		.endif
		xor eax,eax
		ret
	.elseif m==WM_CLOSE
Close:
		invoke EndDialog,hwnd,NULL
		xor eax,eax
		ret
	.elseif m==WM_DESTROY
		invoke DeleteObject,hAboutFont
	.endif

	xor eax,eax
	ret
AboutDialogProc endp

end start
